%date created on 1/12/05: 
%date created on 11/16/04: This is a modified version of work20040812_merge.m
%Merge model parameters /posterior from different windows and from
%different contigs.

function yy = HMM_merge_windows_v5(execdir, para);

load([execdir, para.hyb_data]);
yy.hyb = precious.hyb;
yy.contigs = precious.contigs;

len = size(yy.hyb, 2);
R   = size(yy.hyb, 1);

if para.tie_para == 1,
    S = 1;
else,
    S = R;
end

load([execdir, para.temp_datadir, para.temp_datafile_prefix, ...
    '1', para.temp_datafile_suffix]);
SS = 18;

yy.psnl = zeros(1, len);
yy.pnl = zeros(1, len);
yy.pfl = zeros(1, len);
yy.pln = zeros(1, len);
yy.pll = zeros(1, len);
yy.mean_n = zeros(S, len) + NaN;
yy.mean_f = zeros(S, len) + NaN;
yy.mean_l = zeros(S, len) + NaN;
yy.var_n = zeros(S, len) + NaN;
yy.var_f = zeros(S, len) + NaN;
yy.var_l = zeros(S, len) + NaN;
yy.posts = zeros(SS, len) + NaN;

if para.no_blast == 0,
    yy.blast_weight_n = zeros(S, len) + NaN;
    yy.blast_weight_f = zeros(S, len) + NaN;
    yy.blast_weight_l = zeros(S, len) + NaN;
    yy.entropy_weight_n = zeros(S, len) + NaN;
    yy.entropy_weight_f = zeros(S, len) + NaN;
    yy.entropy_weight_l = zeros(S, len) + NaN;
end


for i = para.select_contigs,
    %for i = 216:216
    select = yy.contigs(i,1):yy.contigs(i,2);
    avg_model = HMM_unroll_windows_v5(execdir, para, yy, i);
    if (length(avg_model))
        yy.psnl(select) = avg_model.psnl;
        yy.pnl(select) = avg_model.pnl;
        yy.pfl(select) = avg_model.pfl;
        yy.pln(select) = avg_model.pln;
        yy.pll(select) = avg_model.pll;
        yy.mean_n(:, select) = avg_model.mean_n;
        yy.mean_f(:, select) = avg_model.mean_f;
        yy.mean_l(:, select) = avg_model.mean_l;
        yy.var_n(:, select) = avg_model.var_n;
        yy.var_f(:, select) = avg_model.var_f;
        yy.var_l(:, select) = avg_model.var_l;
        if para.no_blast == 0,
            yy.blast_weight_n(:, select) = avg_model.blast_weight_n;
            yy.blast_weight_f(:, select) = avg_model.blast_weight_f;
            yy.blast_weight_l(:, select) = avg_model.blast_weight_l;
            yy.entropy_weight_n(:, select) = avg_model.entropy_weight_n;
            yy.entropy_weight_f(:, select) = avg_model.entropy_weight_f;
            yy.entropy_weight_l(:, select) = avg_model.entropy_weight_l;
        end
        yy.posts(:,select) = avg_model.posts;
    end
end

yy.mu_n = zeros(size(yy.mean_n)) + NaN;
yy.mu_f = zeros(size(yy.mean_f)) + NaN;
yy.mu_l = zeros(size(yy.mean_l)) + NaN;

for k = 1:S,
    if para.no_blast == 0,
        yy.mu_n(k,:) = yy.mean_n(k,:)...
            + (yy.blast > 0) .* yy.blast_weight_n(k,:)...
            + yy.entropy .* yy.entropy_weight_n(k,:);
        yy.mu_f(k,:) = yy.mean_f(k,:)...
            + (yy.blast > 0) .* yy.blast_weight_f(k,:)...
            + yy.entropy .* yy.entropy_weight_f(k,:);
        yy.mu_l(k,:) = yy.mean_l(k,:)...
            + (yy.blast > 0) .* yy.blast_weight_l(k,:)...
            + yy.entropy .* yy.entropy_weight_l(k,:);
    else,
        yy.mu_n(k,:) = yy.mean_n(k,:);
        yy.mu_f(k,:) = yy.mean_f(k,:);
        yy.mu_l(k,:) = yy.mean_l(k,:);
    end
end


