%date created: 1/12/05
%Date created: 11/16/04: modeified from Jong's unroll_hmms_v3
%
function avg_model = HMM_unroll_windows_v5(execdir, para, precious, contig)

R = size(precious.hyb, 1);
len = size(precious.hyb, 2);

%load individual window
load([execdir, para.temp_datadir, para.temp_datafile_prefix, ...
    int2str(contig), para.temp_datafile_suffix]);

select = precious.contigs(contig,1):precious.contigs(contig,2);

% If there is only one window, it might be truncated.
if (length(model) == 1)
    win_size = size(model.posts, 2);
else,
    win_size = para.win_size;
end

% Unroll all those windows.
clear avg_model
windows = zeros(length(model), win_size);

%Set number of sets of parameters in HMM model: =1 if tie_para=1; =R if
%tie_para=0.
if para.tie_para == 1,
    S = 1;
else,
    S = R;
end

avg_model.psnl = zeros(1, length(select));
avg_model.pnl = zeros(1, length(select));
avg_model.pfl = zeros(1, length(select));
avg_model.pln = zeros(1, length(select));
avg_model.pll = zeros(1, length(select));
avg_model.mean_n = zeros(S, length(select));
avg_model.mean_f = zeros(S, length(select));
avg_model.mean_l = zeros(S, length(select));
avg_model.var_n = zeros(S, length(select));
avg_model.var_f = zeros(S, length(select));
avg_model.var_l = zeros(S, length(select));

if para.no_blast == 0,
    avg_model.blast_weight_n = zeros(S, length(select));
    avg_model.blast_weight_f = zeros(S, length(select));
    avg_model.blast_weight_l = zeros(S, length(select));
    avg_model.entropy_weight_n = zeros(S, length(select));
    avg_model.entropy_weight_f = zeros(S, length(select));
    avg_model.entropy_weight_l = zeros(S, length(select));
end

for i = 1:length(model)
    windows(i,:) = model(i).psnl;
end
avg_model.psnl = unroll_windows(windows);

for i = 1:length(model)
    windows(i,:) = model(i).pnl;
end
avg_model.pnl = unroll_windows(windows);

for i = 1:length(model)
    windows(i,:) = model(i).pfl;
end
avg_model.pfl = unroll_windows(windows);

for i = 1:length(model)
    windows(i,:) = model(i).pln;
end
avg_model.pln = unroll_windows(windows);

for i = 1:length(model)
    windows(i,:) = model(i).pll;
end
avg_model.pll = unroll_windows(windows);

for k = 1:S,
    for i = 1:length(model)
        windows(i,:) = model(i).mean_n(k);
    end
    avg_model.mean_n(k,:) = unroll_windows(windows);

    for i = 1:length(model)
        windows(i,:) = model(i).mean_f(k);
    end
    avg_model.mean_f(k,:) = unroll_windows(windows);

    for i = 1:length(model)
        windows(i,:) = model(i).mean_l(k);
    end
    avg_model.mean_l(k,:) = unroll_windows(windows);

    for i = 1:length(model)
        windows(i,:) = model(i).var_n(k);
    end
    avg_model.var_n(k,:) = unroll_windows(windows);

    for i = 1:length(model)
        windows(i,:) = model(i).var_f(k);
    end
    avg_model.var_f(k,:) = unroll_windows(windows);

    for i = 1:length(model)
        windows(i,:) = model(i).var_l(k);
    end
    avg_model.var_l(k,:) = unroll_windows(windows);
end

if para.no_blast == 0,
    for k = 1:S,
        for i = 1:length(model)
            windows(i,:) = model(i).blast_weight_n(k);
        end
        avg_model.blast_weight_n(k,:) = unroll_windows(windows);

        for i = 1:length(model)
            windows(i,:) = model(i).blast_weight_f(k);
        end
        avg_model.blast_weight_f(k,:) = unroll_windows(windows);

        for i = 1:length(model)
            windows(i,:) = model(i).blast_weight_l(k);
        end
        avg_model.blast_weight_l(k,:) = unroll_windows(windows);

        for i = 1:length(model)
            windows(i,:) = model(i).entropy_weight_n(k);
        end
        avg_model.entropy_weight_n(k,:) = unroll_windows(windows);

        for i = 1:length(model)
            windows(i,:) = model(i).entropy_weight_f(k);
        end
        avg_model.entropy_weight_f(k,:) = unroll_windows(windows);

        for i = 1:length(model)
            windows(i,:) = model(i).entropy_weight_l(k);
        end
        avg_model.entropy_weight_l(k,:) = unroll_windows(windows);
    end
end

SS = 18;
for j = 1:SS
    for i = 1:length(model)
        windows(i,:) = model(i).posts(j,:);
    end
    avg_model.posts(j,:) = unroll_windows(windows);
end
