% created on 1/12/04: modified from hmm_windows_v4.m; clear nucs may have 6-8
% probes

function HMM_windows_v5(contig, varargin);

argv = varargin;
switch length(argv),
    case 2,
        execdir = argv{1};
        para = argv{2};
    case 1,
        execdir = argv{1};
        SetParameter;
    case 0,
        execdir = pwd;
        SetParameter;
    otherwise,
        error('Invalid number of arguments in HMM_windows');
end

infile = [execdir, para.hyb_data];
outfile = [execdir, para.temp_datadir, para.temp_datafile_prefix, ...
    int2str(contig), para.temp_datafile_suffix];

load(infile);
select = precious.contigs(contig,1):precious.contigs(contig,2);

% Abort if there are any discontinuities.
if (any(any(isnan(precious.hyb(:,select)))))
    error('Gap found in hyb data');
    quit
end

% Moving window.
win_size = min(length(select), para.win_size);
for n = 1:(length(select) - win_size + 1)
    subselect = select(n:(n + win_size - 1));
    if para.no_blast == 0,
        model(n) = nuc_superhmm_v5_with_blast(precious.hyb(:,subselect),...
            precious.blast(subselect), precious.entropy(subselect), ...
            'TiePara', para.tie_para, 'TieFuz', para.tie_fuz);
    else,
        model(n) = nuc_superhmm_v5_no_blast(precious.hyb(:,subselect), ...
            'TiePara', para.tie_para, 'TieFuz', para.tie_fuz);
    end
end

save(outfile, 'model');

if para.cluster_mode == 1,
    quit;
end
